Index: krita/ui/canvas/kis_coordinates_converter.cpp
===================================================================
--- krita/ui/canvas/kis_coordinates_converter.cpp	(revision 0)
+++ krita/ui/canvas/kis_coordinates_converter.cpp	(revision 0)
@@ -0,0 +1,293 @@
+/*
+ *  Copyright (c) 2010 Dmitry Kazakov <dimula73@gmail.com>
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; either version 2 of the License, or
+ *  (at your option) any later version.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
+ */
+
+#include "kis_coordinates_converter.h"
+
+#include <QPolygonF>
+#include <QTransform>
+#include <QSizeF>
+
+#include <KoViewConverter.h>
+
+#include <kis_config.h>
+#include <kis_image.h>
+
+
+struct KisCoordinatesConverter::Private {
+    KisImageWSP image;
+    QSize canvasWidgetSize;
+    KoViewConverter *viewConverter;
+    QPoint documentOffset;
+    QPoint documentOrigin;
+    QTransform postprocessingTransform;
+
+    QTransform imageToDocument;
+    QTransform documentToFlake;
+    QTransform flakeToPostprocessedFlake;
+    QTransform postprocessedFlakeToWidget;
+    QTransform widgetToViewport;
+};
+
+void KisCoordinatesConverter::recalculateTransformations() const
+{
+    if(!m_d->image) return;
+
+    m_d->imageToDocument = QTransform::fromScale(1 / m_d->image->xRes(),
+                                                 1 / m_d->image->yRes());
+
+    qreal zoomX, zoomY;
+    m_d->viewConverter->zoom(&zoomX, &zoomY);
+    m_d->documentToFlake = QTransform::fromScale(zoomX, zoomY);
+
+    // Make new coordinate system not go to negative values
+    QSizeF flakeSize = imageSizeInFlakePixels();
+    QPointF shift = -m_d->postprocessingTransform.mapRect(QRectF(QPointF(0,0), flakeSize)).topLeft();
+
+    m_d->flakeToPostprocessedFlake = m_d->postprocessingTransform
+        * QTransform::fromTranslate(shift.x(), shift.y());
+
+    m_d->postprocessedFlakeToWidget =
+        QTransform::fromTranslate(-m_d->documentOffset.x() + m_d->documentOrigin.x(),
+                                  -m_d->documentOffset.y() + m_d->documentOrigin.y());
+
+
+    QTransform reversedTransform = (m_d->flakeToPostprocessedFlake * m_d->postprocessedFlakeToWidget).inverted();
+
+    QRectF irect = imageRectInWidgetPixels();
+    QRectF wrect = QRectF(QPoint(0,0), m_d->canvasWidgetSize);
+
+    QRectF rrect = irect & wrect;
+
+    QRectF canvasBounds = reversedTransform.mapRect(rrect);
+    QPointF offset = canvasBounds.topLeft();
+
+    reversedTransform = reversedTransform * QTransform::fromTranslate(-offset.x(), -offset.y());
+
+    m_d->widgetToViewport = reversedTransform;
+
+    // qDebug() << "***********";
+    // qDebug() << ppVar(m_d->flakeToPostprocessedFlake);
+    // qDebug() << ppVar(m_d->postprocessedFlakeToWidget);
+    // qDebug() << ppVar(m_d->widgetToViewport);
+    // qDebug() << ppVar(documentOrigin());
+    // qDebug() << ppVar(irect) << ppVar(wrect) << ppVar(rrect);
+    // qDebug() << ppVar(canvasBounds);
+    // qDebug() << ppVar(m_d->widgetToViewport.mapRect(irect));
+}
+
+
+KisCoordinatesConverter::KisCoordinatesConverter(KoViewConverter *viewConverter)
+    : m_d(new Private)
+{
+    m_d->viewConverter = viewConverter;
+}
+
+KisCoordinatesConverter::~KisCoordinatesConverter()
+{
+    delete m_d;
+}
+
+void KisCoordinatesConverter::notifyZoomChanged()
+{
+    recalculateTransformations();
+}
+
+void KisCoordinatesConverter::setCanvasWidgetSize(QSize size)
+{
+    m_d->canvasWidgetSize = size;
+    recalculateTransformations();
+}
+
+void KisCoordinatesConverter::setImage(KisImageWSP image)
+{
+    m_d->image = image;
+    recalculateTransformations();
+}
+
+void KisCoordinatesConverter::setDocumentOrigin(const QPoint &origin)
+{
+    m_d->documentOrigin = origin;
+    recalculateTransformations();
+}
+
+void KisCoordinatesConverter::setDocumentOffset(const QPoint &offset)
+{
+    m_d->documentOffset = offset;
+    recalculateTransformations();
+}
+
+QPoint KisCoordinatesConverter::documentOrigin() const
+{
+    return m_d->documentOrigin;
+}
+
+QPoint KisCoordinatesConverter::documentOffset() const
+{
+    return m_d->documentOffset;
+}
+
+void KisCoordinatesConverter::setPostprocessingTransform(const QTransform &transform)
+{
+    m_d->postprocessingTransform = transform;
+    recalculateTransformations();
+}
+
+QTransform KisCoordinatesConverter::postprocessingTransform() const
+{
+    return m_d->postprocessingTransform;
+}
+
+
+// see a comment in header file
+DEFINE_TRANSFORM_METHODS(imageToDocument, documentToImage,
+                         m_d->imageToDocument);
+
+DEFINE_TRANSFORM_METHODS(flakeToWidget, widgetToFlake,
+                         m_d->flakeToPostprocessedFlake
+                         * m_d->postprocessedFlakeToWidget);
+
+DEFINE_TRANSFORM_METHODS(documentToWidget, widgetToDocument,
+                         m_d->documentToFlake * m_d->flakeToPostprocessedFlake
+                         * m_d->postprocessedFlakeToWidget);
+
+DEFINE_TRANSFORM_METHODS(widgetToViewport, viewportToWidget,
+                         m_d->widgetToViewport);
+
+DEFINE_TRANSFORM_METHODS(imageToViewport, viewportToImage,
+                         m_d->imageToDocument * m_d->documentToFlake
+                         * m_d->flakeToPostprocessedFlake * m_d->postprocessedFlakeToWidget
+                         * m_d->widgetToViewport);
+
+QTransform KisCoordinatesConverter::imageToWidgetTransform() const
+{
+    return m_d->imageToDocument * m_d->documentToFlake
+        * m_d->flakeToPostprocessedFlake * m_d->postprocessedFlakeToWidget;
+}
+
+QTransform KisCoordinatesConverter::documentToWidgetTransform() const
+{
+    return m_d->documentToFlake
+        * m_d->flakeToPostprocessedFlake * m_d->postprocessedFlakeToWidget;
+}
+
+QTransform KisCoordinatesConverter::flakeToWidgetTransform() const
+{
+    return m_d->flakeToPostprocessedFlake * m_d->postprocessedFlakeToWidget;
+}
+
+QTransform KisCoordinatesConverter::viewportToWidgetTransform() const
+{
+    return m_d->widgetToViewport.inverted();
+}
+
+void KisCoordinatesConverter::getQPainterCheckersInfo(QTransform *transform,
+                                                      QPointF *brushOrigin,
+                                                      QPolygonF *polygon) const
+{
+    KisConfig cfg;
+    if (cfg.scrollCheckers()) {
+        *transform = viewportToWidgetTransform();
+        *polygon = imageRectInViewportPixels();
+        *brushOrigin = imageToViewport(QPointF(0,0));
+    }
+    else {
+        *transform = QTransform();
+        *polygon = viewportToWidgetTransform().map(imageRectInViewportPixels());
+        *brushOrigin = QPoint(0,0);
+    }
+}
+
+void KisCoordinatesConverter::getOpenGLCheckersInfo(QTransform *textureTransform,
+                                                    QTransform *modelTransform,
+                                                    QRectF *textureRect,
+                                                    QRectF *modelRect) const
+{
+    KisConfig cfg;
+    QRectF viewportRect = imageRectInViewportPixels();
+
+    *textureTransform = cfg.scrollCheckers() ? QTransform() :
+        m_d->widgetToViewport.inverted() * m_d->postprocessedFlakeToWidget;
+
+    *modelTransform = viewportToWidgetTransform();;
+    *modelRect = viewportRect;
+    *textureRect = QRectF(0, 0, viewportRect.width(),viewportRect.height());
+}
+
+
+// these functions return a bounding rect if the canvas is rotated
+
+QRectF KisCoordinatesConverter::imageRectInWidgetPixels() const
+{
+    if(!m_d->image) return QRectF();
+    return viewportToWidget(imageToViewport(m_d->image->bounds()));
+}
+
+QRectF KisCoordinatesConverter::imageRectInViewportPixels() const
+{
+    if(!m_d->image) return QRectF();
+    return imageToViewport(m_d->image->bounds());
+}
+
+QSizeF KisCoordinatesConverter::imageSizeInFlakePixels() const
+{
+    if(!m_d->image) return QSizeF();
+
+    qreal scaleX, scaleY;
+    imageScale(&scaleX, &scaleY);
+    QSize imageSize = m_d->image->size();
+
+    return QSizeF(imageSize.width() * scaleX, imageSize.height() * scaleY);
+}
+
+QRectF KisCoordinatesConverter::widgetRectInFlakePixels() const
+{
+    // NOTE: this duplicates part of recalculateTransformations()
+    QTransform reversedTransform = (m_d->flakeToPostprocessedFlake * m_d->postprocessedFlakeToWidget).inverted();
+    return reversedTransform.mapRect(QRectF(QPoint(0,0), m_d->canvasWidgetSize));
+}
+
+QPoint KisCoordinatesConverter::shiftFromFlakeCenterPoint(const QPointF &pt) const
+{
+    QTransform transform = m_d->flakeToPostprocessedFlake * m_d->postprocessedFlakeToWidget;
+    QPointF newWidgetCenter = transform.map(pt);
+    QPointF oldWidgetCenter = QPointF(m_d->canvasWidgetSize.width() / 2, m_d->canvasWidgetSize.height() / 2);
+
+    return (newWidgetCenter - oldWidgetCenter).toPoint();
+}
+
+QPointF KisCoordinatesConverter::flakeCenterPoint() const
+{
+    QRectF widgetRect = widgetRectInFlakePixels();
+    return QPointF(widgetRect.left() + widgetRect.width() / 2,
+                   widgetRect.top() + widgetRect.height() / 2);
+}
+
+void KisCoordinatesConverter::imageScale(qreal *scaleX, qreal *scaleY) const
+{
+    // get the x and y zoom level of the canvas
+    qreal zoomX, zoomY;
+    m_d->viewConverter->zoom(&zoomX, &zoomY);
+
+    // Get the KisImage resolution
+    qreal resX = m_d->image->xRes();
+    qreal resY = m_d->image->yRes();
+
+    // Compute the scale factors
+    *scaleX = zoomX / resX;
+    *scaleY = zoomY / resY;
+}
Index: krita/ui/canvas/kis_update_info.h
===================================================================
--- krita/ui/canvas/kis_update_info.h	(revision 1163293)
+++ krita/ui/canvas/kis_update_info.h	(working copy)
@@ -53,8 +53,6 @@
 public:
     KisTextureTileUpdateInfoList tileList;
     QRect dirtyViewportRect();
-
-    QRectF viewportRect;
 };
 #endif /* HAVE_OPENGL */
 
Index: krita/ui/canvas/kis_canvas2.h
===================================================================
--- krita/ui/canvas/kis_canvas2.h	(revision 1163293)
+++ krita/ui/canvas/kis_canvas2.h	(working copy)
@@ -44,6 +44,7 @@
     OPENGL
 };
 
+class KisCoordinatesConverter;
 class KoViewConverter;
 
 /**
@@ -71,6 +72,8 @@
 
     void setCanvasWidget(QWidget * widget);
 
+    void notifyZoomChanged();
+
 public: // KoCanvasBase implementation
 
     bool canvasIsOpenGL();
@@ -104,6 +107,7 @@
 
     virtual void updateInputMethodInfo();
 
+    const KisCoordinatesConverter* coordinatesConverter() const;
     virtual const KoViewConverter *viewConverter() const;
 
     virtual QWidget* canvasWidget();
@@ -135,13 +139,13 @@
 
     bool usingHDRExposureProgram();
     /// @return true if the canvas image should be displayed in vertically mirrored mode
-    bool isCanvasMirrored();
     void addDecoration(KisCanvasDecoration* deco);
     KisCanvasDecoration* decoration(const QString& id);
 
 signals:
 
     void documentOriginChanged();
+    void scrollAreaSizeChanged();
 
     void imageChanged(KisImageWSP image);
 
@@ -167,11 +171,12 @@
     /// adjust the origin of the document
     void adjustOrigin();
 
-    /// documentOffset changed, now update the rulers in zoom manager
-    void updateRulers();
-
     /// slot for setting the mirroring
     void mirrorCanvas(bool mirror);
+    void rotateCanvas(qreal angle);
+    void rotateCanvasRight15();
+    void rotateCanvasLeft15();
+    void resetCanvasTransformations();
 
 private slots:
 
@@ -212,17 +217,11 @@
 private:
     Q_DISABLE_COPY(KisCanvas2);
 
+    void pan(QPoint shift);
     void createCanvas(bool useOpenGL);
     void createQPainterCanvas();
     void createOpenGLCanvas();
 
-    /**
-     * Returns a rect in widget pixels that is translated for document
-     * offset, resolution and zoom and that is guaranteed to be inside
-     * the widget.
-     */
-    QRect viewRectFromDoc(const QRectF & docRect);
-
 private:
 
     class KisCanvas2Private;
Index: krita/ui/canvas/kis_prescaled_projection.h
===================================================================
--- krita/ui/canvas/kis_prescaled_projection.h	(revision 1163293)
+++ krita/ui/canvas/kis_prescaled_projection.h	(working copy)
@@ -32,8 +32,8 @@
 class QSize;
 class QPainter;
 
-class KoViewConverter;
 class KoColorProfile;
+class KisCoordinatesConverter;
 
 #include <kis_types.h>
 
@@ -88,19 +88,8 @@
      */
     QImage prescaledQImage() const;
 
-    /**
-     * Set the view converter, the object that is responsible for
-     * translating between image pixels, document points and view
-     * pixels, keeping track of zoom levels.
-     */
-    void setViewConverter(KoViewConverter * viewConverter);
+    void setCoordinatesConverter(KisCoordinatesConverter *coordinatesConverter);
 
-    /**
-     * Return the intersection of the widget size and the given rect
-     * in image pixels converted to widget pixels.
-     */
-    void updateDocumentOrigin(const QPoint &documentOrigin);
-
 public slots:
 
     /**
@@ -128,10 +117,8 @@
     /**
      * Called whenever the view widget needs to show a different part of
      * the document
-     *
-     * @param documentOffset the offset in widget pixels
      */
-    void documentOffsetMoved(const QPoint &documentOffset);
+    void viewportMoved(const QPointF &offset);
 
     /**
      * Called whenever the size of the KisImage changes
@@ -139,11 +126,13 @@
     void setImageSize(qint32 w, qint32 h);
 
     /**
-     * Resize the prescaled image. The size is given in canvas
-     * widget pixels.
+     * Checks whether it is needed to resize the prescaled image and
+     * updates it. The size is given in canvas widget pixels.
      */
-    void resizePrescaledImage(const QSize & newSize);
+    void notifyCanvasSizeChanged(const QSize &widgetSize);
 
+    void notifyZoomChanged();
+
     /**
      * Set the current monitor profile
      */
@@ -168,6 +157,8 @@
      */
     void initBackend(bool cacheKisImageAsQImage);
 
+    void updateViewportSize();
+
     /**
      * preScale and draw onto the scaled projection the specified rect,
      * in canvas view pixels.
@@ -197,24 +188,6 @@
      */
     void drawUsingBackend(QPainter &gc, KisPPUpdateInfoSP info);
 
-    /**
-     * Converts image pixels into widget pixels
-     * viewRect will always correspond to imageRect (no border
-     * adjustment is done)
-     * Note: caller should check whether viewRect is inside
-     *       canvas area himself
-     */
-    QRectF viewRectFromImagePixels(const QRect& imageRect);
-
-    /**
-     * Converts widget pixels into image pixels
-     * Note1: imageRect will always be adjusted to be inside
-     *        an image, so it _may not_ correspond viewportRect
-     * Note2: caller should check whether viewportRect is inside
-     *        canvas area himself before calling.
-     */
-    QRect imageRectFromViewPortPixels(const QRectF& viewportRect);
-
     struct Private;
     Private * const m_d;
 };
Index: krita/ui/canvas/kis_abstract_canvas_widget.h
===================================================================
--- krita/ui/canvas/kis_abstract_canvas_widget.h	(revision 1163293)
+++ krita/ui/canvas/kis_abstract_canvas_widget.h	(working copy)
@@ -42,19 +42,10 @@
 
     virtual KoToolProxy * toolProxy() = 0;
 
-    virtual void documentOffsetMoved(const QPoint &) = 0;
-
-    virtual QPoint documentOrigin() const = 0;
-
-    virtual void adjustOrigin() = 0;
-
     /**
      * Draw the specified decorations on the view.
      */
-    virtual void drawDecorations(QPainter & gc, bool tools,
-                                 const QPoint & documentOffset,
-                                 const QRect & clipRect,
-                                 KisCanvas2 * canvas) = 0;
+    virtual void drawDecorations(QPainter & gc, const QRect &updateWidgetRect) = 0;
 
     virtual void addDecoration(KisCanvasDecoration* deco) = 0;
     virtual KisCanvasDecoration* decoration(const QString& id) = 0;
Index: krita/ui/canvas/kis_coordinates_converter.h
===================================================================
--- krita/ui/canvas/kis_coordinates_converter.h	(revision 0)
+++ krita/ui/canvas/kis_coordinates_converter.h	(revision 0)
@@ -0,0 +1,132 @@
+/*
+ *  Copyright (c) 2010 Dmitry Kazakov <dimula73@gmail.com>
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; either version 2 of the License, or
+ *  (at your option) any later version.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
+ */
+
+#ifndef KIS_COORDINATES_CONVERTER_H
+#define KIS_COORDINATES_CONVERTER_H
+
+#include "krita_export.h"
+#include "kis_types.h"
+
+
+class QSize;
+class QSizeF;
+class QRectF;
+class QPoint;
+class QPolygonF;
+class QTransform;
+class KoViewConverter;
+
+
+/**
+ * Automatic generation of QRectF and QPointF transformation methods.
+ * They will use pre-generated QTransform objects to perform the change.
+ */
+#define DEFINE_RECT_METHOD(name,transform)                              \
+    QRectF KisCoordinatesConverter::name(const QRectF &rc) const        \
+    {                                                                   \
+        return (transform).mapRect(rc);                                 \
+    }
+
+#define DEFINE_POINT_METHOD(name,transform)                             \
+    QPointF KisCoordinatesConverter::name(const QPointF &pt) const      \
+    {                                                                   \
+        return (transform).map(pt);                                     \
+    }
+
+#define DECLARE_RECT_METHOD(name)               \
+    QRectF name(const QRectF &rc) const
+
+#define DECLARE_POINT_METHOD(name)              \
+    QPointF name(const QPointF &rc) const
+
+
+#define DEFINE_TRANSFORM_METHODS(name,invertedName,transform)         \
+    DEFINE_RECT_METHOD(name, transform);                              \
+    DEFINE_RECT_METHOD(invertedName, (transform).inverted());         \
+    DEFINE_POINT_METHOD(name, transform);                             \
+    DEFINE_POINT_METHOD(invertedName, (transform).inverted())         \
+
+#define DECLARE_TRANSFORM_METHODS(name,invertedName)                   \
+    DECLARE_RECT_METHOD(name);                                         \
+    DECLARE_RECT_METHOD(invertedName);                                 \
+    DECLARE_POINT_METHOD(name);                                        \
+    DECLARE_POINT_METHOD(invertedName)                                 \
+
+
+
+
+class KRITAUI_EXPORT KisCoordinatesConverter
+{
+public:
+    KisCoordinatesConverter(KoViewConverter *viewConverter);
+    ~KisCoordinatesConverter();
+
+    void notifyZoomChanged();
+    void setCanvasWidgetSize(QSize size);
+    void setImage(KisImageWSP image);
+    void setDocumentOrigin(const QPoint &origin);
+    void setDocumentOffset(const QPoint &offset);
+
+    QPoint documentOrigin() const;
+    QPoint documentOffset() const;
+
+    void setPostprocessingTransform(const QTransform &transform);
+    QTransform postprocessingTransform() const;
+
+
+    // Automatic methods generation. See a comment above.
+    DECLARE_TRANSFORM_METHODS(imageToViewport, viewportToImage);
+    DECLARE_TRANSFORM_METHODS(flakeToWidget, widgetToFlake);
+    DECLARE_TRANSFORM_METHODS(widgetToViewport, viewportToWidget);
+    DECLARE_TRANSFORM_METHODS(documentToWidget, widgetToDocument);
+    DECLARE_TRANSFORM_METHODS(imageToDocument, documentToImage);
+
+
+    QTransform imageToWidgetTransform() const;
+    QTransform documentToWidgetTransform() const;
+    QTransform flakeToWidgetTransform() const;
+    QTransform viewportToWidgetTransform() const;
+
+    void getQPainterCheckersInfo(QTransform *transform,
+                                 QPointF *brushOrigin,
+                                 QPolygonF *poligon) const;
+
+    void getOpenGLCheckersInfo(QTransform *textureTransform,
+                               QTransform *modelTransform,
+                               QRectF *textureRect,
+                               QRectF *modelRect) const;
+
+    QRectF imageRectInWidgetPixels() const;
+    QRectF imageRectInViewportPixels() const;
+    QSizeF imageSizeInFlakePixels() const;
+    QRectF widgetRectInFlakePixels() const;
+
+    QPoint shiftFromFlakeCenterPoint(const QPointF &pt) const;
+    QPointF flakeCenterPoint() const;
+
+    void imageScale(qreal *scaleX, qreal *scaleY) const;
+
+private:
+    void recalculateTransformations() const;
+
+private:
+    struct Private;
+    Private * const m_d;
+};
+
+#endif /* KIS_COORDINATES_CONVERTER_H */
Index: krita/ui/canvas/kis_canvas_widget_base.cpp
===================================================================
--- krita/ui/canvas/kis_canvas_widget_base.cpp	(revision 1163293)
+++ krita/ui/canvas/kis_canvas_widget_base.cpp	(working copy)
@@ -29,6 +29,8 @@
 #include <KoViewConverter.h>
 #include <KoToolProxy.h>
 
+
+#include "kis_coordinates_converter.h"
 #include "kis_canvas_decoration.h"
 #include "../kis_config.h"
 #include "kis_canvas2.h"
@@ -38,8 +40,9 @@
 class KisCanvasWidgetBase::Private
 {
 public:
-    Private(KisCanvas2 *newCanvas)
+    Private(KisCanvas2 *newCanvas, KisCoordinatesConverter *newCoordinatesConverter)
         : canvas(newCanvas)
+        , coordinatesConverter(newCoordinatesConverter)
         , viewConverter(newCanvas->viewConverter())
         , toolProxy(newCanvas->toolProxy())
         , ignorenextMouseEventExceptRightMiddleClick(0)
@@ -48,20 +51,17 @@
 
     QList<KisCanvasDecoration*> decorations;
     KisCanvas2 * canvas;
+    KisCoordinatesConverter *coordinatesConverter;
     const KoViewConverter * viewConverter;
     KoToolProxy * toolProxy;
-    /// the offset of the view in the document, expressed in the view reference (not in the document reference)
-    QPoint documentOffset;
-    /// the origin of the image rect
-    QPoint origin;
     QTimer blockMouseEvent;
     
     bool ignorenextMouseEventExceptRightMiddleClick; // HACK work around Qt bug not sending tablet right/dblclick http://bugreports.qt.nokia.com/browse/QTBUG-8598
     QColor borderColor;
 };
 
-KisCanvasWidgetBase::KisCanvasWidgetBase(KisCanvas2 * canvas)
-    : m_d(new Private(canvas))
+KisCanvasWidgetBase::KisCanvasWidgetBase(KisCanvas2 * canvas, KisCoordinatesConverter *coordinatesConverter)
+    : m_d(new Private(canvas, coordinatesConverter))
 {
     m_d->blockMouseEvent.setSingleShot(true);
 }
@@ -71,39 +71,41 @@
     delete m_d;
 }
 
-void KisCanvasWidgetBase::drawDecorations(QPainter & gc, bool tools,
-                                          const QPoint & documentOffset,
-                                          const QRect & clipRect,
-                                          KisCanvas2 * canvas)
+void KisCanvasWidgetBase::drawDecorations(QPainter & gc, const QRect &updateWidgetRect)
 {
+    gc.save();
+
     // Setup the painter to take care of the offset; all that the
     // classes that do painting need to keep track of is resolution
     gc.setRenderHint(QPainter::Antialiasing);
     gc.setRenderHint(QPainter::TextAntialiasing);
-//     gc.setRenderHint(QPainter::HighQualityAntialiasing); // http://www.archivum.info/qt-interest@trolltech.com/2010-01/00481/Re:-(Qt-interest)-Is-QPainter::HighQualityAntialiasing-render-hint-broken-in-Qt-4.6.html <- this option does not do anything anymore with Qt4.6, so don't reenable it since it seems to break display
+
+    // This option does not do anything anymore with Qt4.6, so don't reenable it since it seems to break display
+    // http://www.archivum.info/qt-interest@trolltech.com/2010-01/00481/Re:-(Qt-interest)-Is-QPainter::HighQualityAntialiasing-render-hint-broken-in-Qt-4.6.html
+    // gc.setRenderHint(QPainter::HighQualityAntialiasing);
+
     gc.setRenderHint(QPainter::SmoothPixmapTransform);
-    gc.translate(QPoint(-documentOffset.x(), -documentOffset.y()));
-    gc.translate(documentOrigin());
 
-    // Paint the shapes (other than the layers)
+
     gc.save();
-    gc.setClipRect(clipRect);
-    canvas->globalShapeManager()->paint(gc, *canvas->viewConverter(), false);
+    gc.setClipRect(updateWidgetRect);
+
+    QTransform transform = m_d->coordinatesConverter->flakeToWidgetTransform();
+    gc.setTransform(transform);
+
+    // Paint the shapes (other than the layers)
+    m_d->canvas->globalShapeManager()->paint(gc, *m_d->viewConverter, false);
+
+    // some tools do not restore gc, but that is not important here
+    toolProxy()->paint(gc, *m_d->viewConverter);
     gc.restore();
 
     // ask the decorations to paint themselves
     foreach(KisCanvasDecoration* deco, m_d->decorations) {
-        gc.save();
-        deco->paint(gc, documentOffset, clipRect, *canvas->viewConverter());
-        gc.restore();
+        deco->paint(gc, m_d->coordinatesConverter->widgetToDocument(updateWidgetRect), m_d->coordinatesConverter);
     }
 
-    // Give the tool a chance to paint its stuff
-    if (tools) {
-        gc.save();
-        toolProxy()->paint(gc, *canvas->viewConverter());
-        gc.restore();
-    }
+    gc.restore();
 }
 
 void KisCanvasWidgetBase::addDecoration(KisCanvasDecoration* deco)
@@ -135,19 +137,25 @@
 {
     KisConfig cfg;
 
+    if(checkSize < 0)
+        checkSize = cfg.checkSize();
+
+    QColor checkColor = cfg.checkersColor();
+
     QImage tile(checkSize * 2, checkSize * 2, QImage::Format_RGB32);
     QPainter pt(&tile);
     pt.fillRect(tile.rect(), Qt::white);
-    pt.fillRect(0, 0, checkSize, checkSize, cfg.checkersColor());
-    pt.fillRect(checkSize, checkSize, checkSize, checkSize, cfg.checkersColor());
+    pt.fillRect(0, 0, checkSize, checkSize, checkColor);
+    pt.fillRect(checkSize, checkSize, checkSize, checkSize, checkColor);
     pt.end();
 
     return tile;
 }
 
-void KisCanvasWidgetBase::setBorderColor(const QColor& color)
+void KisCanvasWidgetBase::notifyConfigChanged()
 {
-    m_d->borderColor = color;
+    KisConfig cfg;
+    m_d->borderColor = cfg.canvasBorderColor();
 }
 
 QColor KisCanvasWidgetBase::borderColor() const
@@ -160,9 +168,9 @@
     return m_d->canvas;
 }
 
-const KoViewConverter *KisCanvasWidgetBase::viewConverter() const
+KisCoordinatesConverter* KisCanvasWidgetBase::coordinatesConverter()
 {
-    return m_d->viewConverter;
+    return m_d->coordinatesConverter;
 }
 
 KoToolProxy *KisCanvasWidgetBase::toolProxy()
@@ -170,104 +178,15 @@
     return m_d->toolProxy;
 }
 
-QPoint KisCanvasWidgetBase::documentOffset() const
-{
-    return m_d->documentOffset;
-}
-
-QPoint KisCanvasWidgetBase::documentOrigin() const
-{
-    return m_d->origin;
-}
-
-void KisCanvasWidgetBase::documentOffsetMoved(const QPoint & pt)
-{
-    m_d->documentOffset = pt;
-}
-
-QSize KisCanvasWidgetBase::documentSize() const
-{
-    KisImageWSP image = m_d->canvas->image();
-    return QSize(int(ceil(m_d->viewConverter->documentToViewX(image->width()  / image->xRes()))),
-                 int(ceil(m_d->viewConverter->documentToViewY(image->height() / image->yRes()))));
-}
-
-void KisCanvasWidgetBase::adjustOrigin()
-{
-    KisImageWSP image = m_d->canvas->image();
-    if (image == 0) return;
-
-    QRect documentRect = QRect(QPoint(0, 0), documentSize());
-
-    // save the old origin to see if it has changed
-    QPoint oldOrigin = m_d->origin;
-
-    // set the origin to the zoom document rect origin
-    m_d->origin = -documentRect.topLeft();
-
-    // the document bounding rect is always centered on the virtual canvas
-    // if there are margins left around the zoomed document rect then
-    // distribute them evenly on both sides
-    int widthDiff = widget()->size().width() - documentRect.width();
-    if (widthDiff > 0)
-        m_d->origin.rx() += qRound(0.5 * widthDiff);
-    int heightDiff = widget()->size().height() - documentRect.height();
-    if (heightDiff > 0)
-        m_d->origin.ry() += qRound(0.5 * heightDiff);
-
-    emitDocumentOriginChangedSignal();
-}
-
-
-QPointF KisCanvasWidgetBase::widgetToDocument(const QPointF& p) const
-{
-    if (m_d->canvas->isCanvasMirrored())
-    {   
-        return mirror(m_d->viewConverter->viewToDocument(widgetToView(p + m_d->documentOffset)));
-    }else{
-        return m_d->viewConverter->viewToDocument(widgetToView(p + m_d->documentOffset));
-    }
-}
-
-QPointF KisCanvasWidgetBase::mirror(const QPointF& pos) const
-{
-    QSizeF imageSize = m_d->viewConverter->viewToDocument(documentSize());
-    return QPointF(imageSize.width() - pos.x(), pos.y() );
-}
-
 QPointF KisCanvasWidgetBase::mouseEventWidgetToDocument(const QPoint& mousePosition) const
 {
     const qreal PIXEL_CENTRE_OFFSET = 0.5;
     const QPointF pixelCentre(mousePosition.x() + PIXEL_CENTRE_OFFSET,
                               mousePosition.y() + PIXEL_CENTRE_OFFSET);
-    return widgetToDocument(pixelCentre);
-}
 
-
-QPointF KisCanvasWidgetBase::widgetToView(const QPointF& p) const
-{
-    return p - m_d->origin;
+    return m_d->coordinatesConverter->widgetToDocument(pixelCentre);
 }
 
-
-QRect KisCanvasWidgetBase::widgetToView(const QRect& r) const
-{
-    return r.translated(- m_d->origin);
-}
-
-
-QPoint KisCanvasWidgetBase::viewToWidget(const QPoint& p) const
-{
-    return p + m_d->origin;
-}
-
-
-QRect KisCanvasWidgetBase::viewToWidget(const QRect& r) const
-{
-    return r.translated(m_d->origin);
-}
-
-
 void KisCanvasWidgetBase::processMouseMoveEvent(QMouseEvent *e)
 {
     if (m_d->ignorenextMouseEventExceptRightMiddleClick )
@@ -376,7 +295,7 @@
     m_d->blockMouseEvent.start(100);
 
     const QPointF pos = e->hiResGlobalPos() - widget()->mapToGlobal(QPoint(0, 0));
-    m_d->toolProxy->tabletEvent(e, widgetToDocument(pos));
+    m_d->toolProxy->tabletEvent(e, m_d->coordinatesConverter->widgetToDocument(pos));
 
     // HACK
     e->ignore();
@@ -386,7 +305,7 @@
 
 void KisCanvasWidgetBase::processWheelEvent(QWheelEvent *e)
 {
-    m_d->toolProxy->wheelEvent(e, widgetToDocument(e->pos()));
+    m_d->toolProxy->wheelEvent(e, m_d->coordinatesConverter->widgetToDocument(e->pos()));
 }
 
 
